#include "huck.h"
#include <stdlib.h>
#include <stdio.h>

#define DEPTH 20
char previous[DEPTH+1];
int empty = 0;

void garbage(double f1)
{
    int ncontinuation[DEPTH], i, j, k, bign = strlen(book), nuse, indx;
    if (empty)
        for (i = 0; i < DEPTH; i++)
            previous[i] = 0;
    for (i = 0; i < DEPTH; i++)
        ncontinuation[i] = 0;
    for (i = 0; i < bign; i++)
    {
        for (j = i, k = 0; j >= 0 && k < DEPTH; j--, k++)
        {
            ncontinuation[k]++;
            if (previous[k] != book[j])
                break;
        }
    }
#if 0    
    for (i = 0; i < 10; i++)
        printf("%7.4d", ncontinuation[i]);
    printf("\n");
#endif
#if 1
        /* figure out how many characters to use */
    for (nuse = 0; nuse < DEPTH-1; nuse++)
        if (ncontinuation[nuse+1] < f1)
            break;
#else
    nuse = f1;
#endif
    indx = (random() * (double)(ncontinuation[nuse])) / RAND_MAX;
    if (indx >= ncontinuation[nuse])
        indx--;

    for (i = 0; i < DEPTH; i++)
        ncontinuation[i] = 0;
    /* printf("nuse %d, indx %d prev %s\n", nuse, indx, previous); */
    /* printf("nuse %d\n", nuse); */
    for (i = 0; i < bign; i++)
    {
        for (j = i, k = 0; j >= 0 && k < DEPTH; j--, k++)
        {
            if ((k == nuse) && (ncontinuation[k] == indx))
            {
                int nexti = i+1, nextc, k2;
                if (nexti >= bign)
                    nextc = ' ';
                else nextc = book[nexti];
                fprintf(stderr, "%c", nextc);
                for (k2 = DEPTH-1; k2 >0; k2--)
                    previous[k2] = previous[k2-1];
                previous[0] = nextc;
            }
            ncontinuation[k]++;
            if (previous[k] != book[j])
                break;
        }
    }
}

main()
{
    int i;
/*    for (i = 0; i < 3; i++)
        garbage(i); */
    for (i = 0; i < 10000; i++)
        garbage(2);
    fprintf(stderr, "\n");
}
